#!/usr/bin/perl
#
# Convert a text file to a video memory
#

eval { use bytes; };
eval { binmode STDOUT; };

if ( $ARGV[0] eq '-40' ) {
    $width = 40;
} else {
    $width = 80;
}

@vmem = (" " x $width) x 24;

$l = 0;
while ( defined($line = <STDIN>) ) {
    chomp $line;
    last if ( $l >= 24 );
    $line = substr($line, 0, $width);
    substr($vmem[$l++], 0, length($line)) = $line;
}

$bits = "\xff" x 2048;

for ( $l = 0 ; $l < 24 ; $l++ ) {
    if ( $width == 40 ) {
	$a = 1024 + ((($l >> 3)*5) << 3) + (($l & 7) << 7);
    } else {
	$a = ((($l >> 3)*5) << 4) + (($l & 7) << 8);
    }
    substr($bits,$a,$width) = $vmem[$l];
}

print $bits;
